#ifndef __CFG_H
#define __CFG_H

/*
 * Copyright (C) 2002 Bartosz Lis <bartoszl@ics.p.lodz.pl>
 * This is the main module
 */

#include "config.h"

#include "textrope.h"

typedef struct cfg_field {
  struct cfg_field *next;
  int               status;
  char             *lvalue;
  char             *rvalue;
} cfg_field_t;

#define FLD_FOR_UPDATE  0x1
#define FLD_FOR_INSERT  0x2
#define FLD_FOR_INSUPD  (FLD_FOR_UPDATE | FLD_FOR_INSERT)

cfg_field_t *
cfg_field_new(textrope_t *tr_left, textrope_t *tr_right, int status);

void
cfg_field_destroy(cfg_field_t **cf);

cfg_field_t *
cfg_field_join(cfg_field_t **cf1, cfg_field_t **cf2);

#endif /*__CFG_H*/
